/* TurboC v1.5 & v2.0 Source File */
/*  STRSORT.C  -- String Sorting for Turbo Prolog v2.0 where
    the input list is modified at its source
*/

#include <prolist.h>  /* List defines and typedefs */
#include <string.h>   /* For the string Processing */

/*  The Structure of the Incomming list appears (logically) as follows...
          +++++++++++++       +++++++++++++
InList    +char NodeTy+       +char NodeTy+
  |-----> +ptr   *Next------> +ptr   *Next-------#
          +ptr    *Str--:     +ptr    *Str--:
          +++++++++++++ :     +++++++++++++ :
                        :                   :
                        `-->"Str1",0        `-->"Str2",0

This routine Compares the Strings (case ignored) and switches the POINTERS
to the strings (NOT the strings themselves) appropriatly.  Note that the
main list structure (holding the NodeType) is not switched, nor are the NEXT
pointers switched, simply the pointers to the strings will suffice  */

void strsort_0(StrList *InList)    /* Performs DESCENDING Bubble sort */
  {
    StrList *Anchor, *Current;
    char *Temp;

    Anchor = InList;
    while ((Anchor->NodeType) != is_null)
      {
        Current = Anchor;
        while ((Current->NodeType) != is_null)
          {
            if (_stricmp((Current->Str), (Anchor->Str)) > 0)
              {  Temp = Current->Str;
                 (Current->Str) = (Anchor->Str);
                 Anchor->Str = Temp;
              }
            Current = Current->Next;
          };
        Anchor = Anchor->Next;
      };
  };
